Wc1 = 25000; Wc2 = 32000; % Requirement for the bandpass filter
Ws1 = 12000; Ws2 = 60000;
Amax = 0.28; Amin = 60;
if Wc1*Wc2 <= Ws1*Ws2; % Modify band edges if needed
Ws2 = Wc1*Wc2/Ws1;
else
Ws1 = Wc1*Wc2/Ws2;
end
WI2 = Wc1*Wc2;
Omegac = Wc2 - Wc1; % Requirements for lowpass filter
Omegas = Ws2 - Ws1;
NLP = CA_ORDER(Omegac, Omegas, Amax, Amin)% Synthesis of LP filter
NLP = 3; % Select the next higher integer
[GLP, ZLP, R_ZEROSLP, PLP, Wsnew] = CA_POLES(Omegac, Omegas, Amax, Amin, N);
QLP = -abs(PLP)./(2*real(PLP))
% Transform the lowpass to a bandpass filter
[GBP, ZBP, PBP] = PZ_2_G_SYM_BP_S(GLP, ZLP, PLP, WI2);
figure(1)
PLOT_PZ_S(ZBP, PBP, 0, 0, -40000, 10000, 80000)
ZBP
PBP
GBP
QBP = -abs(PBP)./(2*real(PBP))
W = [0:100:100000];
H = PZ_2_FREQ_S(GBP, ZBP, PBP, W);
figure(2)
axis_Amax = 80; axis_Tg_max = 1.6*10^-3;
Att = MAG_2_ATT(H); % Compute the attenuation
Tg = PZ_2_TG_S(GBP, ZBP, PBP, W); % Compute the group delay
PLOT_A_TG_S(Att, Tg, W, axis_Amax, axis_Tg_max);
set(gca,'FontName', 'times', 'FontSize', 16);
