clear all
Wc = 30000; Ws = 8000;
Amax = 0.1; Amin = 40; % Requirements for the highpass filter
WI = Wc; % We select WI = Wc
Omegac = Wc; % Omegac = WI^2/Wc?Wc
Omegas = WI^2/Ws;
NLP = 5; % Synthesis of 5th-order lowpass Butterworth filter
[GLP, ZLP, PLP] = BW_POLES(Omegac, Omegas, Amax, Amin, NLP)
QLP = -abs(PLP)./(2*real(PLP))
% Transform the LP to a HP filter
[GHP, ZHP, PHP] = PZ_2_HP_S(GLP, ZLP, PLP, WI^2)
N = NLP; % LP and HP filter has the same order
QHP = -abs(PHP)./(2*real(PHP))
